
/*

 Copyright  2004,2005,2006 Birger N. Andreasen 
 Please send any bugreports, comments and other issues to:
 E-Mail = bna@post10.tele.dk
 Homepage with other ROTT stuff = http://home14.inet.tele.dk/Bna-Info

*/ 

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <time.h>
#include "glfuncs.h"


BOOL CH_LoadCrosshair();
void CH_DrawCrosshair(unsigned char* s);

typedef struct {
    unsigned int  startx;
    unsigned int  starty;
    unsigned char color;
    unsigned char data[11*11];
} crosshair;

crosshair Crosshair;

BOOL   IsCrosshairLoaded = FALSE;
extern char ApogeePath[256];
extern playerweaponindex;//1-16

BOOL CH_LoadCrosshair()
{
	char *ptr;
	int  i;
	FILE *stream;
	char defcrosshair[]="startx=155\r\n"
						"starty=100\r\n"
						"color=75\r\n"
						"data=0 0 0 0 0 0 0 0 0 0 0\r\n"
							 "0 0 0 0 0 1 0 0 0 0 0\r\n"
							 "0 0 0 0 0 1 0 0 0 0 0\r\n"
							 "0 0 0 0 0 1 0 0 0 0 0\r\n"
							 "0 0 0 0 0 0 0 0 0 0 0\r\n"
							 "1 1 1 1 0 0 0 1 1 1 1\r\n"
							 "0 0 0 0 0 0 0 0 0 0 0\r\n"
							 "0 0 0 0 0 1 0 0 0 0 0\r\n"
							 "0 0 0 0 0 1 0 0 0 0 0\r\n"
							 "0 0 0 0 0 1 0 0 0 0 0\r\n"
							 "0 0 0 0 0 0 0 0 0 0 0\r\n";


	//do we have a crosshair.ifo in the gl folder
	if( (stream = fopen(".\\gl\\crosshair.ifo", "r" )) == NULL ){
		//none found, try current folder
		if( (stream = fopen("crosshair.ifo", "r" )) == NULL ){
			//none atall found, write default values 
			if( (stream = fopen( ".\\gl\\crosshair.ifo", "w" )) == NULL ){
				return 0;
			}
			fwrite( defcrosshair, sizeof( defcrosshair ), 1, stream );
			fclose( stream );
			return 0;
		}
	}

	//read data from file
    fread(defcrosshair, sizeof( defcrosshair ), 1, stream );
    fclose( stream );

	//find the datas
	ptr = strstr(defcrosshair,"startx");
	if (ptr == 0)
		return 0;
	ptr = strstr(ptr,"=");
	if (ptr == 0)
		return 0;
	Crosshair.startx = atol(ptr+1);

	ptr = strstr(defcrosshair,"starty");
	if (ptr == 0)
		return 0;
	ptr = strstr(ptr,"=");
	if (ptr == 0)
		return 0;
	Crosshair.starty = atol(ptr+1);

	ptr = strstr(defcrosshair,"color");
	if (ptr == 0)
		return 0;
	ptr = strstr(ptr,"=");
	if (ptr == 0)
		return 0;
	Crosshair.color = (char)atol(ptr+1);


	ptr = strstr(defcrosshair,"data");
	if (ptr == 0)
		return 0;
	ptr = strstr(ptr,"=");
	if (ptr == 0)
		return 0;


//STM();
	for (i=0;i <= (11*11); i++){
		if (*ptr == 13)
			ptr++;
		if (*ptr == 10)
			ptr++;
		if (*ptr == '=')
			*ptr++;
		while(*ptr == ' ')
			ptr++;		
		*(Crosshair.data+i) = (char)atol(ptr);
		ptr++;
	}

	IsCrosshairLoaded = TRUE;
	return TRUE;
}




void CH_DrawCrosshair(unsigned char* s)
{
	int xc,yc,datacnt = 0;
	char* sx = s + (Crosshair.starty * 320) + Crosshair.startx ;
	//we dont want to use cros going up at the moment
	//char* sx = s + ((Crosshair.starty-(6*playerweaponindex)) * 320) + Crosshair.startx ;	
	if (IsCrosshairLoaded == FALSE){
		CH_LoadCrosshair();
		if (IsCrosshairLoaded == FALSE){
			return;
		}
	}

//STM();
	for (yc=0; yc< 11; yc++){
		for (xc=0; xc< 11; xc++){
			if (Crosshair.data[datacnt++] == 1)
				*(sx+xc) = Crosshair.color;
		}
		sx += 320;
	}

}



